(*
  Bifton - A Pascal- compiler.

  Copyright (C) 2004 Samuel Mimram & Julien Cristau.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(**
  Instructions for sparc asm.

  @author Julien Cristau
*)

(* $Id: instr_sparc.ml,v 1.5 2004/05/09 20:02:08 julio Exp $ *)

(** load rs rd loads the value at rs in rd *)
let load a b = "\tld\t" ^ a ^ ", " ^ b ^ "\n" 
(** store rs rd stores the content of rs at rd *)
let store a b = "\tst\t" ^ a ^ ", " ^ b ^ "\n"
(** nop does nothing ;) *)
let nop = "\t nop\n"
(** unconditional jump at a label *)
let jmp l = "\tba\t" ^ l ^ "\n"
(** conditional branch *)
let branch b l = "\t" ^ b ^ "\t" ^ l ^ "\n"
(** integer addition *)
let add a b c = "\tadd\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
(** integer substraction *)
let sub a b c = "\tadd\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
(** register copy *)
let move a b = "\tmov\t" ^ a ^ ", " ^ b ^ "\n"
(** function call *)
let call f = "\tcall\t" ^ f ^ "\n"
let save a b c = "\tsave\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
let restore = "\trestore\n"
(** comparison *)
let cmp a b = "\tcmp\t" ^ a ^ ", " ^ b ^ "\n"
let subcc a b c = "\tsubcc\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
let push a = "\tpush\t" ^ a ^ "\n"
let wry a b = "\twr\t" ^ a ^ ", " ^ b ^ ", %y\n"
let mult a b c = "\tsmul\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
let div a b c = "\tsdiv\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
let rdy a = "\trd\t%y, " ^ a ^ "\n"
let ret = "\tret\n"
let set a b = "\tset\t" ^ a ^ ", " ^ b ^ "\n"
let log_or a b c = "\tor\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
let log_and a b c = "\tand\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
let xor a b c = "\txor\t" ^ a ^ ", " ^ b ^ ", " ^ c ^ "\n"
