(*
  Bifton - A Pascal- compiler.

  Copyright (C) 2004 Samuel Mimram & Julien Cristau.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(**
  Parameters of the compiler.

  @author Samuel Mimram, Julien Cristau
*)

(* $Id: params.mli,v 1.5 2004/05/03 15:31:01 smimou Exp $ *)

(**
  Maximum number of registers.
*)
val registers_nb : int ref

(**
  Remove functions which are not referenced by nobody.
*)
val remove_useless_functions : bool ref

(**
  Try to minimize variable spills.
*)
val minimize_spills : bool ref

(**
  Try to use flags instead of 32bits booleans when it's possible.
*)
val use_flags : bool ref

(**
  Do some local optimizations on the generated code.
*)
val local_opts : bool ref
